<?php
namespace api;

include_once("./_entity.php");

use api;
use core;


class User extends  api\Entity
{
    function login($input=[])
    {
        $data = core\getVal($input,"data",[]);

        $pass = core\getVal($data,"pass");
        $email = core\getVal($data,"email");

        $req = [];
        $req["table"] = "user";
        $req["where"] = 
        "
            WHERE data->'$.email' = '$email'
            AND data->'$.password' = '$pass'
        ";

        $req["fields"] = [" data->>'$.role' as role"];

        $res_view = parent::view($req);

        $id = core\getVal($res_view,"id");
        
        if($id)
        {
            $auth_res =  $this->auth->set($res_view);
            $res["auth"] =  core\getVal($auth_res,"id");
            $auth_id = core\getVal($auth_res,"id");
            $this->startSession();

            $_SESSION['auth_id'] = $auth_id;
    
            $res["status"] = "success";
        }

        return $res;
    }

    function logout($input=[])
    {
        $this->startSession();
        session_unset();
        session_destroy();
        $res["status"] = "success";
        return $res;
    }

    function getUser($input=[])
    {
        $auth_id = core\getVal($_SESSION,"auth_id",-100);

        if($auth_id==-100) return [];
        else
        {

            $a = $this->auth->validate(["id"=>$auth_id]);

            if(!$a) return [];
            $auth = $this->auth->view($a);
    
            $req["id"] = core\getVal($auth,"user_id",-100);
            $view = $this->view($req);
    
            $id = core\getVal($view,"id",false);
            if(!$id) return ["id"=>-100];
    
            // $res["name"] = core\getVal($view,"name")." ".core\getVal($view,"surname");
            $res["role"] = core\getVal($view,"role");
            if($res["name"]=="") $res["name"] = core\getVal($view,"email"); 
            $res["email"] = core\getVal($view,"email");
            $res["auth_id"] = $auth_id;
        }

        return $res;
    }
}

$e = new User();